function HashItem() {
this.ucDepth = 0;
this.ucFlag = 0;
this.sv1 = 0;
this.wmv = 0;
this.wReserved = 0;
this.dwLock0 = 0;
this.dwLock1 = 0;
}

window.Search = {};

Search.nHistoryTable = new Array(65536);

Search.mvResult = 0;

Search.mvKillers = new Array(gCommon.LIMIT_DEPTH);

Search.HashTable = new Array(gCommon.HASH_SIZE);

Search.Init = function() {
Search.mvResult = 0;
for (var e = 0; e < 65536; e++) Search.nHistoryTable[e] = 0;
for (e = 0; e < gCommon.LIMIT_DEPTH; e++) Search.mvKillers[e] = [ 0, 0 ];
for (e = 0; e < gCommon.HASH_SIZE; e++) Search.HashTable[e] = new HashItem();
};

window.HashTable = {};

HashTable.ProbeHash = function(e, s) {
var t = Search.HashTable[s.zobr.dwKey & gCommon.HASH_SIZE - 1];
if (t.dwLock0 != s.zobr.dwLock0 || t.dwLock1 != s.zobr.dwLock1) {
e.mv = 0;
return -gCommon.MATE_VALUE;
}
e.mv = t.wmv;
var o = !1;
if (t.svl > gCommon.WIN_VALUE) {
t.svl -= s.nDistance;
o = !0;
} else if (t.svl < -gCommon.WIN_VALUE) {
t.svl += s.nDistance;
o = !0;
}
return t.ucDepth >= e.nDepth || o ? t.ucFlag == gCommon.HASH_BETA ? t.svl >= e.vlBeta ? t.svl : -gCommon.MATE_VALUE : t.ucFlag == gCommon.HASH_ALPHA ? t.svl <= e.vlAlpha ? t.svl : -gCommon.MATE_VALUE : t.svl : -gCommon.MATE_VALUE;
};

HashTable.RecordHash = function(e, s) {
var t = Search.HashTable[s.zobr.dwKey & gCommon.HASH_SIZE - 1];
if (!(t.ucDepth > e.nDepth)) {
t.ucFlag = e.nFlag;
t.ucDepth = e.nDepth;
e.vl > gCommon.WIN_VALUE ? t.svl = e.vl + s.nDistance : e.vl < -gCommon.WIN_VALUE ? t.svl = e.vl - s.nDistance : t.svl = e.vl;
t.wmv = e.mv;
t.dwLock0 = s.zobr.dwLock0;
t.dwLock1 = s.zobr.dwLock1;
Search.HashTable[s.zobr.dwKey & gCommon.HASH_SIZE - 1] = t;
}
};

HashTable.SetBestMove = function(e, s, t) {
Search.nHistoryTable[e] += s * s;
var o = Search.mvKillers[t.nDistance];
if (o[0] != e) {
o[1] = o[0];
o[0] = e;
}
};

window.SortStruct = function() {
this.mvHash = 0;
this.mvKiller1 = 0;
this.mvKiller2 = 0;
this.nPhase = 0;
this.nIndex = 0;
this.mvs = null;
};

SortStruct.prototype = {
constructor: SortStruct,
Init: function(e, s) {
this.mvHash = e;
this.mvKiller1 = Search.mvKillers[s.nDistance][0];
this.mvKiller2 = Search.mvKillers[s.nDistance][1];
this.nPhase = gCommon.PHASE_HASH;
},
Next: function(e) {
switch (this.nPhase) {
case gCommon.PHASE_HASH:
this.nPhase = gCommon.PHASE_KILLER_1;
if (0 != this.mvHash) return this.mvHash;

case gCommon.PHASE_KILLER_1:
this.nPhase = gCommon.PHASE_KILLER_2;
if (this.mvKiller1 != this.mvHash && 0 != this.mvKiller1 && e.LegalMove(this.mvKiller1)) return this.mvKiller1;

case gCommon.PHASE_KILLER_2:
this.nPhase = gCommon.PHASE_GEN_MOVES;
if (this.mvKiller2 != this.mvHash && 0 != this.mvKiller2 && e.LegalMove(this.mvKiller2)) return this.mvKiller2;

case gCommon.PHASE_GEN_MOVES:
this.nPhase = gCommon.PHASE_REST;
this.mvs = e.GenerateMoves(!1);
this.mvs.sort(CompareHistory);
this.nIndex = 0;

case gCommon.PHASE_REST:
for (;this.nIndex < this.mvs.length; ) {
var s = this.mvs[this.nIndex];
this.nIndex++;
if (s != this.mvHash && s != this.mvKiller1 && s != this.mvKiller2) return s;
}

default:
return 0;
}
}
};